#ifndef _KERN_LOCK_H
#define _KERN_LOCK_H

#include <kern/kernel.h>
#include <kern/spinlock.h>
#include <kern/thread.h>
#include <util/spinlock.h>

namespace Lock {
	extern int dying;

	struct Lock {
		SpinLock spinlock;
		Threads::WaitQueue waitqueue;
		ulong lockval;
		
		Lock()
		{
			lockval = 0;
		}
		
		void lock();
		void unlock();

		bool held_by_curthread()
		{
			return lockval == reinterpret_cast<ulong>(curthread);
		}
	};
}

#endif
