// mem/orbmm.cc -- The ORB memory manager for the kernel address space
//
// This software is copyright (c) 2006 Scott Wood <scott@buserror.net>.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal with
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following condition:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE
// SOFTWARE.

#include <kern/mem.h>
#include <kern/paging.h>

namespace System {
namespace RunTime {
	ORBMM orbmm_real;
	ORBMM *orbmm = &orbmm_real;
	
	ORBMM::ORBMM()
	{
		priv = NULL;
	}

	void *ORBMM::alloc(size_t size, AllocGroup *group)
	{
		return reinterpret_cast<void *>(new u8[size]);
	}
	
	void ORBMM::retain(Region region)
	{
		// FIXME
	}

	void ORBMM::release(Region region)
	{
		// FIXME
	}
}
}	
